Unit MNB9R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNB9R(N :Integer; var X :Array of Real;
                var S :Array of Real; var XX :Array of Real;
                var EPS :Real; H :Real; var A :Real; var B :Real;
                var FA :Real; var FB :Real; var K :Integer; FUN :Proc_F1_MN;
                var IERR :Integer);

implementation

procedure MNB9R(N :Integer; var X :Array of Real;
                var S :Array of Real; var XX :Array of Real;
                var EPS :Real; H :Real; var A :Real; var B :Real;
                var FA :Real; var FB :Real; var K :Integer; FUN :Proc_F1_MN;
                var IERR :Integer);
var
I :Integer;
ALFA,F,F0,F1,F2,FE,Y,Y0,Y1,Y2,Z0,Z1,Z2 :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180;
begin
K := 0;
Y0 := 0.0;
ALFA := 0.0;
FUN(X,F0,FE);
K := K + 1;
_10:
Y := Y0 + EPS;
for I:=1 to N do
 begin
  XX[I-1] := X[I-1] + Y*S[I-1];
_20:
 end;
FUN(XX,F,FE);
K := K + 1;
if ( F <>  F0 ) 
 then goto _50;
if ( EPS ) < 0
 then goto _30
 else if ( EPS ) > 0
       then goto _40
       else goto _30;
_30:
IERR := 66;
goto _180;
_40:
EPS := -EPS;
goto _10;
_50:
if ( F - F0 ) < 0
 then goto _60
 else if ( F - F0 ) > 0
       then goto _70
       else goto _60;
_60:
Y1 := Y;
F1 := F;
goto _80;
_70:
Y1 := Y0;
F1 := F0;
Y0 := Y;
F0 := F;
ALFA := ALFA + EPS;
_80:
EPS := EPS + EPS;
if ( Abs(ALFA) - H ) < 0
 then goto _90
 else if ( Abs(ALFA) - H ) > 0
       then goto _110
       else goto _90;
_90:
Y2 := Y1 + EPS;
for I:=1 to N do
 begin
  XX[I-1] := X[I-1] + Y2*S[I-1];
_100:
 end;
FUN(XX,F2,FE);
K := K + 1;
Z0 := X[0] + Y0;
Z1 := X[0] + Y1;
Z2 := X[0] + Y2;
goto _130;
_110:
Y2 := H;
if ( EPS <  0.0 ) 
 then Y2 := -H;
for I:=1 to N do
 begin
  XX[I-1] := X[I-1] + Y2*S[I-1];
_120:
 end;
FUN(XX,F2,FE);
K := K + 1;
Z0 := X[0] + Y0;
Z1 := X[0] + Y1;
Z2 := X[0] + Y2;
IERR := 65;
goto _140;
_130:
if ( F2 >=  F1 ) 
 then goto _140;
Y0 := Y1;
F0 := F1;
Y1 := Y2;
F1 := F2;
ALFA := ALFA + EPS;
goto _80;
_140:
if ( EPS ) < 0
 then goto _150
 else if ( EPS ) > 0
       then goto _160
       else goto _150;
_150:
A := Y2;
FA := F2;
B := Y0;
FB := F0;
goto _170;
_160:
A := Y0;
FA := F0;
B := Y2;
FB := F2;
_170:
IERR := 0;
_180:
end;

end.
